test_that("giterator.intervals works", {
    expect_regression(giterator.intervals("test.fixedbin", gintervals(c(1, 2), 0, 1000000)), "giterator.intervals.1")
    expect_regression(giterator.intervals("test.fixedbin", gintervals(c(2, 3))), "giterator.intervals.2")
    expect_regression(giterator.intervals("test.fixedbin", gintervals(c(2, 3)), iterator = 120), "giterator.intervals.3")
    expect_regression(giterator.intervals("test.rects", gintervals.2d(c(2, 3)), iterator = c(100000, 200000)), "giterator.intervals.4")
    expect_regression(giterator.intervals("test.computed2d", gintervals.2d(chroms1 = c(6, 1, 5), chroms2 = c(8, 1, 9))), "giterator.intervals.5")
    expect_error(giterator.intervals(NULL, gintervals(c(2, 3))))
    expect_regression(giterator.intervals(NULL, gintervals(c(2, 3)), iterator = 120), "giterator.intervals.7")
    expect_regression(giterator.intervals(NULL, .misha$ALLGENOME, iterator = "test.sparse"), "giterator.intervals.8")
    expect_regression(giterator.intervals(NULL, gintervals(c(2, 3)), iterator = "test.sparse"), "giterator.intervals.9")
    expect_regression(giterator.intervals(NULL, gintervals(c(2, 3)), iterator = "test.fixedbin"), "giterator.intervals.10")
    expect_regression(giterator.intervals("test.sparse", gintervals(c(1, 2), 0, 1000000)), "giterator.intervals.11")
    expect_regression(giterator.intervals(NULL, iterator = "test.rects_big_rects", band = c(-187435, 234560)), "giterator.intervals.12")
    expect_regression(giterator.intervals(NULL, gintervals.2d(c(2, 3)), iterator = c(12345, 789), band = c(-18743, 23456)), "giterator.intervals.13")
    expect_regression(giterator.intervals("test.generated_1d_1", intervals = giterator.intervals("test.generated_1d_2"), iterator = giterator.intervals("test.generated_1d_1")), "giterator.intervals.14")
    expect_regression(giterator.intervals("test.generated_1d_1", intervals = giterator.intervals("test.generated_1d_2"), iterator = "test.bigintervs_1d_1"), "giterator.intervals.15")
    expect_regression(giterator.intervals("test.generated_1d_1", intervals = giterator.intervals("test.generated_1d_2"), iterator = "test.generated_1d_1"), "giterator.intervals.16")
    expect_regression(giterator.intervals("test.generated_1d_1", intervals = "test.bigintervs_1d_2", iterator = giterator.intervals("test.generated_1d_1")), "giterator.intervals.17")
    expect_regression(giterator.intervals("test.generated_1d_1", intervals = "test.bigintervs_1d_2", iterator = "test.bigintervs_1d_1"), "giterator.intervals.18")
    expect_regression(giterator.intervals("test.generated_1d_1", intervals = "test.bigintervs_1d_2", iterator = "test.generated_1d_1"), "giterator.intervals.19")
    expect_regression(giterator.intervals("test.generated_1d_1", intervals = "test.generated_1d_2", iterator = giterator.intervals("test.generated_1d_1")), "giterator.intervals.20")
    expect_regression(giterator.intervals("test.generated_1d_1", intervals = "test.generated_1d_2", iterator = "test.bigintervs_1d_1"), "giterator.intervals.21")
    expect_regression(giterator.intervals("test.generated_1d_1", intervals = "test.generated_1d_2", iterator = "test.generated_1d_1"), "giterator.intervals.22")
    expect_regression(giterator.intervals("test.generated_2d_5", intervals = giterator.intervals("test.generated_2d_6"), iterator = giterator.intervals("test.generated_2d_5")), "giterator.intervals.23")
    expect_regression(giterator.intervals("test.generated_2d_5", intervals = giterator.intervals("test.generated_2d_6"), iterator = "test.bigintervs_2d_5"), "giterator.intervals.24")
    expect_regression(giterator.intervals("test.generated_2d_5", intervals = giterator.intervals("test.generated_2d_6"), iterator = "test.generated_2d_5"), "giterator.intervals.25")
    expect_regression(giterator.intervals("test.generated_2d_5", intervals = "test.bigintervs_2d_6", iterator = giterator.intervals("test.generated_2d_5")), "giterator.intervals.26")
    expect_regression(giterator.intervals("test.generated_2d_5", intervals = "test.bigintervs_2d_6", iterator = "test.bigintervs_2d_5"), "giterator.intervals.27")
    expect_regression(giterator.intervals("test.generated_2d_5", intervals = "test.bigintervs_2d_6", iterator = "test.generated_2d_5"), "giterator.intervals.28")
    expect_regression(giterator.intervals("test.generated_2d_5", intervals = "test.generated_2d_6", iterator = giterator.intervals("test.generated_2d_5")), "giterator.intervals.29")
    expect_regression(giterator.intervals("test.generated_2d_5", intervals = "test.generated_2d_6", iterator = "test.bigintervs_2d_5"), "giterator.intervals.30")
    expect_regression(giterator.intervals("test.generated_2d_5", intervals = "test.generated_2d_6", iterator = "test.generated_2d_5"), "giterator.intervals.31")
    expect_regression(giterator.intervals("test.generated_2d_6", "test.bigintervs_2d_5"), "giterator.intervals.32")
    expect_regression(giterator.intervals("test.generated_2d_6", "test.generated_2d_5"), "giterator.intervals.33")
    expect_error(giterator.intervals("test.generated_1d_1", intervals = "test.fixedbin"))
    expect_error(giterator.intervals("test.generated_1d_1", intervals = "test.generated_2d_5"))
    expect_error(giterator.intervals("test.generated_2d_6", "test.sparse"))
})
